#include "FastLED.h"

#include "pitches.h"

#define NUM_LEDS 16 // Número de leds de la tira
#define DATA_PIN 4  // El pin en la placa de arduino para conectar con el pin de datos de la tira

CRGB leds[NUM_LEDS];
CRGB colors[4];

// define los pines
int ldr = A0;
int ldr2 = A1;
int altavoz = 7;
// define variables donde almacenar los valores
int valorLuz = 0;
int valorLuz2 = 0;

int notas[] = {
  NOTE_C4, NOTE_D4, NOTE_E4, NOTE_F4, NOTE_G4, NOTE_A4, NOTE_B4,
  NOTE_C5, NOTE_D5, NOTE_E5, NOTE_F5, NOTE_G5, NOTE_A5, NOTE_B5,
  NOTE_C6, NOTE_D6, NOTE_E6, NOTE_F6, NOTE_G6, NOTE_A6, NOTE_B6,
  NOTE_C7, NOTE_D7, NOTE_E7, NOTE_F7, NOTE_G7, NOTE_A7, NOTE_B7,
  NOTE_C8
};

void setup() {
      //Sistama prevenci´n por si los leds chupan todo el voltaje
      delay(100);
      Serial.begin(9600);
      //Contructor de la libreria (Driver, el pin de los datos, 
      FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS);
      // inicializa la salida de audio
      pinMode(ldr, INPUT); 
      pinMode(ldr2, INPUT); 
      pinMode(altavoz, OUTPUT);
    
      }

void loop() {
  valorLuz = analogRead(ldr);
  valorLuz2 = analogRead(ldr2);
  int nivelLuz=map(valorLuz,370,740,0,NUM_LEDS);
  int frecuencia=map(valorLuz,370,740,0, 8);
  int nivelLuz2=map(valorLuz2,370,740,0, 4);

  if(frecuencia == 8) frecuencia = 7;
  if(frecuencia < 0) frecuencia = 0;
  if(nivelLuz2 == 4) nivelLuz2 = 3;
  if(nivelLuz2 < 0) nivelLuz2 = 0;

  Serial.println("Frecuencia: ");
  Serial.println(frecuencia);

  Serial.println("Nivel Luz: ");
  Serial.println(nivelLuz2);

  colors[0] = CRGB::Red;
  colors[1] = CRGB::Orange;
  colors[2] = CRGB::Green;
  colors[3] = CRGB::Blue;


  for (int j = 0; j < NUM_LEDS; j++) {
    if (j < nivelLuz) {
     leds[j] = colors[nivelLuz2];
    }else{
     leds[j] = CRGB::Black;
    }
  }    
  FastLED.show();

  if(valorLuz>360){
    tone(altavoz, notas[frecuencia+(nivelLuz2*7)]);
    Serial.println("Nota: ");
    Serial.println(notas[frecuencia+(nivelLuz2*7)]);
  }else{
    noTone(altavoz);
  }
  
  delay(300);
}
  
